diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/kernel/sched.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/kernel/sched.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/kernel/sched.c	2004-08-03 19:33:52.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/kernel/sched.c	2005-08-12 15:41:58.000000000 -0600
@@ -532,6 +532,9 @@ needs_resched:
 asmlinkage void schedule_tail(struct task_struct *prev)
 {
 	__schedule_tail(prev);
+#ifdef CONFIG_ADEOS_EVENT_ENTER_PROCESS
+	__adeos_enter_process();
+#endif /* CONFIG_ADEOS_EVENT_ENTER_PROCESS */
 }
 
 /*
@@ -551,6 +554,10 @@ asmlinkage void schedule(void)
 	struct list_head *tmp;
 	int this_cpu, c;
 
+#ifdef CONFIG_ADEOS_CORE
+	if (adp_current != adp_root) /* Let's be helpful and conservative. */
+	    return;
+#endif /* CONFIG_ADEOS_CORE */
 
 	spin_lock_prefetch(&runqueue_lock);
 
@@ -668,7 +675,13 @@ repeat_schedule:
 	 * but prev is set to (the just run) 'last' process by switch_to().
 	 * This might sound slightly confusing but makes tons of sense.
 	 */
+#ifdef CONFIG_ADEOS_CORE
+	prepare_to_switch(prev, next);
+	/* disable hw-irqs (for sake of LXRT scheduler), are re-enabled after switch */
+	adeos_hw_cli();
+#else /* !CONFIG_ADEOS_CORE */
 	prepare_to_switch();
+#endif /* CONFIG_ADEOS_CORE */
 	{
 		struct mm_struct *mm = next->mm;
 		struct mm_struct *oldmm = prev->active_mm;
@@ -693,6 +706,13 @@ repeat_schedule:
 	 * stack.
 	 */
 	switch_to(prev, next, prev);
+#ifdef CONFIG_ADEOS_CORE
+	adeos_hw_sti();
+	if (__adeos_schedule_tail(prev) > 0)
+	    /* Some event handler asked for a truncated
+	       scheduling tail. Just obey. */
+	    return;
+#endif /* CONFIG_ADEOS_CORE */
 	__schedule_tail(prev);
 
 same_process:
@@ -702,6 +722,20 @@ same_process:
 	return;
 }
 
+#ifdef CONFIG_ADEOS_CORE
+
+void __adeos_schedule_back_root (struct task_struct *prev)
+
+{
+    __schedule_tail(prev);
+    reacquire_kernel_lock(current);
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+}
+
+#endif /* CONFIG_ADEOS_CORE */
+
 /*
  * The core wakeup function.  Non-exclusive wakeups (nr_exclusive == 0) just wake everything
  * up.  If it's an exclusive wakeup (nr_exclusive == small +ve number) then we wake all the
@@ -989,6 +1023,13 @@ static int setscheduler(pid_t pid, int p
 		goto out_unlock;
 
 	retval = 0;
+#ifdef CONFIG_ADEOS_EVENT_RENICE_PROCESS
+	{
+	struct { struct task_struct *task; int policy; struct sched_param *param; } evdata = { p, policy, &lp };
+	if (__adeos_renice_process(&evdata))
+	    goto out_unlock;
+	}
+#endif /* CONFIG_ADEOS_EVENT_RENICE_PROCESS */
 	p->policy = policy;
 	p->rt_priority = lp.sched_priority;
 
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/kernel/signal.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/kernel/signal.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/kernel/signal.c	2004-08-03 19:33:52.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/kernel/signal.c	2005-08-12 15:41:58.000000000 -0600
@@ -496,6 +496,13 @@ static inline void signal_wake_up(struct
 {
 	t->sigpending = 1;
 
+#ifdef CONFIG_ADEOS_CORE
+	{
+	struct { struct task_struct *t; } evdata = { t };
+	__adeos_kick_process(&evdata);
+	}
+#endif /* CONFIG_ADEOS_CORE */
+
 #ifdef CONFIG_SMP
 	/*
 	 * If the task is running on a different CPU 
@@ -554,6 +561,17 @@ printk("SIG queue (%s:%d): %d ", t->comm
 	if (!sig || !t->sig)
 		goto out_nolock;
 
+#ifdef CONFIG_ADEOS_CORE
+	/* If some domain handler in the pipeline doesn't ask for
+	   propagation, return success pretending that 'sig' was
+	   delivered. */
+	{
+	struct { struct task_struct *task; int sig; } evdata = { t, sig };
+	if (__adeos_signal_process(&evdata))
+	    goto out_nolock;
+	}
+#endif /* CONFIG_ADEOS_CORE */
+
 	spin_lock_irqsave(&t->sigmask_lock, flags);
 	handle_stop_signal(sig, t);
 
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/kernel/sysctl.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/kernel/sysctl.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/kernel/sysctl.c	2004-08-03 19:33:52.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/kernel/sysctl.c	2005-08-12 15:41:58.000000000 -0600
@@ -360,6 +360,9 @@ void __init sysctl_init(void)
 #ifdef CONFIG_PROC_FS
 	register_proc_table(root_table, proc_sys_root);
 	init_irq_proc();
+#ifdef CONFIG_ADEOS_CORE
+	__adeos_init_proc();
+#endif /* CONFIG_ADEOS_CORE */
 #endif
 }
 
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/Makefile linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/Makefile
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/Makefile	2005-03-11 09:02:10.000000000 -0700
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/Makefile	2005-08-12 15:42:54.000000000 -0600
@@ -1,7 +1,7 @@
 VERSION = 2
 PATCHLEVEL = 4
 SUBLEVEL = 26
-EXTRAVERSION =-vrs1-cirrus-1-2-1-ts8
+EXTRAVERSION =-vrs1-cirrus-1-2-1-ts8-rt
 
 KERNELRELEASE=$(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)
 
@@ -18,7 +18,7 @@ FINDHPATH	= $(HPATH)/asm $(HPATH)/linux 
 
 HOSTCC  	= gcc
 HOSTCFLAGS	= -Wall -Wstrict-prototypes -Os -fomit-frame-pointer
-CROSS_COMPILE = $(shell cd $(TOPDIR)/../../tools/crosstool/arm-9tdmi-linux-gnu/gcc-3.3.4-glibc-2.3.2/bin/ && pwd)/arm-9tdmi-linux-gnu-
+CROSS_COMPILE   = /usr/local/opt/crosstool/arm-linux/gcc-3.3.4-glibc-2.3.2/bin/arm-linux-
 #
 # Include the make variables (CC, etc...)
 #
@@ -34,7 +34,7 @@ OBJCOPY		= $(CROSS_COMPILE)objcopy
 OBJDUMP		= $(CROSS_COMPILE)objdump
 MAKEFILES	= $(TOPDIR)/.config
 GENKSYMS	= /sbin/genksyms
-DEPMOD		= /sbin/depmod
+DEPMOD		= /usr/local/opt/crosstool/arm-linux/gcc-3.3.4-glibc-2.3.2/sbin/depmod
 MODFLAGS	= -DMODULE
 CFLAGS_KERNEL	=
 PERL		= perl
@@ -126,13 +126,14 @@ CORE_FILES	=kernel/kernel.o mm/mm.o fs/f
 NETWORKS	=net/network.o
 
 LIBS		=$(TOPDIR)/lib/lib.a
-SUBDIRS		=kernel drivers mm fs net ipc lib crypto
+SUBDIRS		=kernel adeos drivers mm fs net ipc lib crypto
 
 DRIVERS-n :=
 DRIVERS-y :=
 DRIVERS-m :=
 DRIVERS-  :=
 
+DRIVERS-$(CONFIG_ADEOS) += adeos/built-in.o
 DRIVERS-$(CONFIG_ACPI_BOOT) += drivers/acpi/acpi.o
 DRIVERS-$(CONFIG_PARPORT) += drivers/parport/driver.o
 DRIVERS-$(CONFIG_I2C) += drivers/i2c/i2c.o
diff -urNpb linux-2.4.26-vrs1-cirrus-1-2-1-ts8/mm/memory.c linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/mm/memory.c
--- linux-2.4.26-vrs1-cirrus-1-2-1-ts8/mm/memory.c	2004-08-03 19:33:53.000000000 -0600
+++ linux-2.4.26-vrs1-cirrus-1-2-1-ts8-rt/mm/memory.c	2005-08-12 15:41:58.000000000 -0600
@@ -492,13 +492,32 @@ int get_user_pages(struct task_struct *t
 
 		vma = find_extend_vma(mm, start);
 
+#if 0
 		if ( !vma || (pages && vma->vm_flags & VM_IO) || !(flags & vma->vm_flags) )
+#else
+		/* fix for lock-up upon mlockall() & mmap(/dev/mem) (i.e. to access
+		 * hardware in real-time process) */
+		int vm_io = vma ? vma->vm_flags & VM_IO : 0;
+		if (!vma || (pages && vm_io) || !(flags & vma->vm_flags))
+#endif
 			return i ? : -EFAULT;
 
 		spin_lock(&mm->page_table_lock);
 		do {
+#if 0
 			struct page *map;
 			while (!(map = follow_page(mm, start, write))) {
+#else
+			/* fix for lock-up upon mlockall() & mmap(/dev/mem) (i.e. to access
+			 * hardware in real-time process) */
+			struct page *map = NULL;
+			/*
+			 * We don't follow pagetables for VM_IO regions - they
+			 * have no pageframes. And the caller passed NULL
+			 * for `pages' anyway.
+			 */
+			while (!vm_io && !(map = follow_page(mm,start,write))) { 
+#endif
 				spin_unlock(&mm->page_table_lock);
 				switch (handle_mm_fault(mm, vma, start, write)) {
 				case 1:
